#ifndef FIFO_H
#define FIFO_H
#include "Arduino.h"
#include <stdint.h>

class FIFO
{
	public:
		FIFO(uint8_t *memory, uint16_t sizeAllocated);	// use: uint8_t arr[80]; FIFO fifo(arr[0],80);
		bool notFull();			// true if there is place for another fifo.push(val)
		bool notEmpty();		// true if fifo.get() can return something
		virtual uint8_t push(uint8_t val);	// return val. If fifo is already full, then nothing is changed
		virtual uint8_t get();			// if notEmpty() then returns next value, else returns 0
		// ----
		uint8_t peek();			// returns what get would return now, but does not change anything
		uint16_t Free();		// number of actually free positions
		uint16_t Used();		// number of actually used positions
		uint16_t Total();		// total size of FIFO = sizeAllocated from constructor
		uint16_t Total_Count();		// returns total_count of tried pushes
	protected:
		uint8_t  *mem;			// pointer na buffer
		uint16_t size;			// sizeAllocated
		uint16_t used;			// used; basically head-tail
		uint16_t head;			// the index, where value will be inserted
		uint16_t tail;			// the index of most historical value, which will be returned by get()
		uint16_t total_count;		// of push's
};

#endif
