#ifndef FIFO_TEXT_H
#define FIFO_TEXT_H
#include "FIFO.h"

class FIFO_text : public FIFO
{
	public:
		FIFO_text(uint8_t *memory, uint16_t sizeAllocated);	// use: uint8_t arr[80]; FIFO fifo(arr[0],80);
		uint8_t push(uint8_t val) override ;			// return val. If fifo is already full, then nothing is changed
		uint8_t get() override ;				// if notEmpty() then returns next value, else returns 0
		void clear();						// reset head, tail, and used to 0. Called in get, if the FIFO is Empty afterward
		// ----
		static bool isBlank(uint8_t c);				// c is ' ', \t, \r, \n or zero
		// ----
		bool startSpace() { return firstBlank; };		// peek() will return Blank
		bool startEoln() { return firstEoln; };			// peek() will return \r or \n or zero
		bool haveWord() { return Word; };			// buffer have some nonBlank followed by some Blank
		bool haveEoln() { return Eoln; };			// buffer have \r or \n or zero
	protected:
		void rescan();						// sets firstBlank, Word, Eoln
		bool firstBlank;
		bool firstEoln;
		bool Word;
		bool Eoln;
};

#endif

