; Test Serial	verze 002	start at 0200
; Záměr:
; 	testy pro Expanduino_I
; 	R/W se zeptá na Exp.Serial (0..3). W posílá stisknuté klávesy až do <ESC> (mimo, pošle $00); Read čte a zobrazuje dokud nepřijde $00.
; 
; 	Pro práci s porty použije knihovny "systému", který tímto začnu budovat
; 	Až bude "systém" dost mohutný a otestovaný, tak ho přenesu do ROM místo původního firmwaru (Monitor2)
; 	nebo spíš ještě něco jako jeho bootloader, aby šel dál rozvíjet snadno
WTF	MACRO	; {{{ tohle ještě musím dodělat 
	FCN	"Work To Future here"
	ENDM	; }}}
;
	BSS
	ORG	$0000
	CODE
	ORG	$0200
;
	JSR	Sys.PrintImm
	FCN	CR,LF,"Pokusný řetězec",CR,LF
	LDA	#$12
	JSR	Sys.PrintHex
	LDA	#$9A
	JSR	Sys.PrintHex
	LDA	#$BC
	JSR	Sys.PrintHex
	JSR	Sys.PrintImm
	FCN	"---",CR,LF
; --- {{{ test na dump registru Regs: A: DE; B: AD; CC: 00; DP: 56; X: CAFE; Y: BEEF; S: 7FFF; U: BABE; PC: 0249;
	LDA	#$56
	TFR	A,DP
	LDA	#$DE
	LDB	#$AD
	LDX	#$CAFE
	LDY	#$BEEF
	LDU	#$BABE
	ANDCC	#0
	JSR	Sys.DumpRegs
; }}}
; --- {{{ test na cteni dat z pameti
	BRA	>
Test.data
	FCB	$80, $81, $82, $83, $84, $85, $86, $87, $88, $89, $8A, $8B, $8C, $8D, $8E, $8F
	FCB	$90, $91, $92, $93, $94, $95, $96, $97, $98, $99, $9A, $9B, $9C, $9D, $9E, $9F
!
	LDX	#Test.data
	LDA	,X
	LDB	5,X
	ANDCC	#0
	JSR	Sys.DumpRegs
; }}}
	JMP Sys.Entry
;
; Konstanty
ACIA		EQU	$83FE	; 6850 ACIA
INT_RESET	EQU	$FFFE	; system reset vector
; {{{ Řetězce
CR		EQU	$0D
LF		EQU	$0A
Prompt		EQU	"?"
VERSION_A	EQU	"00"
VERSION_B	EQU	"00"
VERSION_C	EQU	"01"
; }}}
; SYSTÉM
	CODE
	ALIGN	$100
Sys.Start
	EXPORT	Sys.Start
				; Inicialization of Expanduino - read (and discard) all ReadRegisters without waiting for avaiability to set sane initial SR-regs status (maybe lose 1.byte from before boot) {{{
	LDA	Exp.Serial_Status
	NOP
	LDA	Exp.Serial1_In
	NOP
	LDA	Exp.Serial2_In
	NOP
	LDA	Exp.Serial3_In
	NOP
				; OK, from now we should follow protocol }}}
	JMP Sys.Entry
	FCN "System"
; {{{ Sys.DefaultSerial_*
Sys.DefaultSerial_Status	EQU	ACIA+0
Sys.DefaultSerial_In		EQU	ACIA+1
Sys.DefaultSerial_In_Mask	EQU	$01
Sys.DefaultSerial_Out		EQU	ACIA+1
Sys.DefaultSerial_Out_Mask	EQU	$02
; }}}
Sys.Entry
	EXPORT	Sys.Entry
	JSR	Sys.PrintImm
	FCN	"System ",VERSION_A, ".",VERSION_B,".",VERSION_C,CR,LF
	JMP	Sys.Loop
; ---
Sys.PrintImm	; {{{ Print Immediate on default Serial
	EXPORT Sys.PrintImm
	PSHS	A,X
	LDX	3,S
1			; local label 1
	LDA	,X+
	BNE	>	; 0F - forward to next local label 0
	STX	3,S
	PULS	A,X,PC
!			; local label 0
	JSR	Sys.PrintReg
	JMP	1B	; back to local label 1
; }}}
Sys.PrintReg	; {{{ Print A reg on default Serial
	EXPORT Sys.PrintReg
	PSHS	A
!		; local label 0
	LDA	Sys.DefaultSerial_Status
	ANDA	#Sys.DefaultSerial_Out_Mask
	BEQ	<	; 0B - back to last local label 0
	PULS	A
	STA	Sys.DefaultSerial_Out
	RTS
; }}}
Sys.ReadReg	; {{{ Read A reg from default Serial
	EXPORT Sys.ReadReg
!			; local label 0
	LDA	Sys.DefaultSerial_Status
	ANDA	#Sys.DefaultSerial_In_Mask
	BEQ	<	; 0B - back to last local label 0
	LDA	Sys.DefaultSerial_In
	RTS
; }}}
Sys.RegToUpper	; {{{ Convert reg A to Uppercase
	EXPORT Sys.RegToUpper
	CMPA	#"a"
	BLT	>
	CMPA	#"z"
	BGT	>
	ANDA	# $FF ^ "a - "A
!
	RTS
; }}}
Sys.RegToLower	; {{{ Convert reg A to Lowercase
	EXPORT Sys.RegToUpper
	CMPA	#"A"
	BLT	>
	CMPA	#"Z"
	BGT	>
	ORA	# "a - "A
!
	RTS
; }}}
Sys.bin2hex	; {{{ A -> A,B ascii hexa
	TFR	A,B
	LSRA
	LSRA
	LSRA
	LSRA
	CMPA	#9
	BLS	>
	ADDA	# 'A - '9 - 1
!	ADDA	#'0
	ANDB	#$0F
	CMPB	#9
	BLS	>
	ADDB	# 'A - '9 - 1
!	ADDB	#'0
	RTS
; }}}
Sys.PrintHex	; {{{ Print A reg on default Serial as hexa
	PSHS	A,B
	JSR	Sys.bin2hex
	JSR	Sys.PrintReg
	EXG	A,B
	JSR	Sys.PrintReg
	PULS	A,B
	RTS
; }}}
Sys.PrintBin	; {{{ Print A reg on default Serial as binary
	PSHS	A,B
	TFR	A,B
	LDA	#8
	PSHS	A
!	LDA	#'0
	ASLB
	ADCA	#0
	JSR	Sys.PrintReg
	DEC	,S
	BNE	<
	PULS	A
	PULS	A,B
	RTS
; }}}
Sys.DumpRegs	; {{{ Print all regs on default Serial as hexa
	PSHS	CC,A,B,DP,X,Y,U
	;
	JSR	Sys.PrintImm
	FCN	CR,LF,"Regs: A: "
	JSR	Sys.PrintHex
	;
	JSR	Sys.PrintImm
	FCN	"; B: "
	EXG	A,B
	JSR	Sys.PrintHex
	;
	JSR	Sys.PrintImm
	FCN	"; CC: "
	LDA	,S
	JSR	Sys.PrintHex
	;
	JSR	Sys.PrintImm
	FCN	"; DP: "
	LDA	3,S
	JSR	Sys.PrintHex
	;
	JSR	Sys.PrintImm
	FCN	"; X: "
	LDA	4,S
	JSR	Sys.PrintHex
	LDA	5,S
	JSR	Sys.PrintHex
	;
	JSR	Sys.PrintImm
	FCN	"; Y: "
	LDA	6,S
	JSR	Sys.PrintHex
	LDA	7,S
	JSR	Sys.PrintHex
	;
	JSR	Sys.PrintImm
	FCN	"; S: "
	LEAX	11,S
	TFR	X,D
	JSR	Sys.PrintHex
	EXG	A,B
	JSR	Sys.PrintHex
	;
	JSR	Sys.PrintImm
	FCN	"; U: "
	LDA	8,S
	JSR	Sys.PrintHex
	LDA	9,S
	JSR	Sys.PrintHex
	;
	JSR	Sys.PrintImm
	FCN	"; PC: "
	LDA	10,S
	JSR	Sys.PrintHex
	LDA	11,S
	JSR	Sys.PrintHex
	;
	JSR	Sys.PrintImm
	FCN	";",CR,LF
	;
	PULS	CC,A,B,DP,X,Y,U
	RTS

; }}}
;---
Sys.SerReadStat		; {{{ Read A reg from given Serial Status (X -> SerialStruct)
	EXPORT Sys.SerReadStat
	LDA	[,X]	; Serial_Status
	RTS
; }}}
Sys.SerReadReg	; {{{ Read A reg from given Serial (X -> SerialStruct)
	EXPORT Sys.SerReadReg
!			; local label 0
	LDA	[,X]	; Serial_Status
	ANDA	2,X	; Serial_InMask
	BEQ	<	; 0B - back to last local label 0
	LDA	[4,X]	; Serial_In
	RTS
; }}}
Sys.SerPrintReg	; {{{ Print A reg on given Serial (X -> SerialStruct)
	EXPORT Sys.SerPrintReg
	PSHS	A
!		; local label 0
	LDA	[,X]	; Serial_Status
	ANDA	3,X	; Serial_OutMask
	BEQ	<	; 0B - back to last local label 0
	PULS	A
	STA	[6,X]	; Serial_Out
	RTS
; }}}
Sys.SerReadEmpty		; {{{ Is Serial Read Empty? (X -> SerialStruct) BEQ Empty_notReadyToRead, BNE canBeRead
	EXPORT Sys.SerReadEmpty
	PSHS	A
	LDA	[,X]	; Serial_Status
	ANDA	2,X	; Serial_InMask
	PULS	A
	RTS
; }}}
Sys.SerWriteFull		; {{{ Is Serial Write Full? (X -> SerialStruct) BEQ Full_notReadyToWrite, BNE canBeWritten
	EXPORT Sys.SerWriteFull
	PSHS	A
	LDA	[,X]	; Serial_Status
	ANDA	3,X	; Serial_InMask
	PULS	A
	RTS
; }}}
Serial	MACRO	; {{{ Name, SerialStruct {Serial_Status, Serial_InMask, Serial_OutMask, Serial_In, Serial_Out}
\1	FDB	\2
	FCB	\3,\4
	FDB	\5,\6
	EXPORT	\1
	ENDM	; }}}
;	Serial	"Ser1", Serial_Status, Serial_InMask, Serial_OutMask, Serial_In, Serial_Out
	Serial	"Ser1", Sys.DefaultSerial_Status, Sys.DefaultSerial_In_Mask, Sys.DefaultSerial_Out_Mask, Sys.DefaultSerial_In, Sys.DefaultSerial_Out
Sys.StartAddr	FDB Sys.Start
Sys.Lenght	FDB Sys.End-Sys.Start
Sys.End
	EXPORT Sys.End
; ---
	ALIGN $100
; Expanduino
; {{{ Exp.DefaultSerial_*
EXPANDUINO	EQU	$9000	; Expanduino board base address
Exp.Serial_Status	EQU	EXPANDUINO+0
Exp.Serial_Status_Mask	EQU	$01
Exp.Control_Out		EQU	EXPANDUINO+0
Exp.Control_Out_Mask	EQU	$02
Exp.Serial1_In		EQU	EXPANDUINO+1
Exp.Serial1_In_Mask	EQU	$04
Exp.Serial1_Out		EQU	EXPANDUINO+1
Exp.Serial1_Out_Mask	EQU	$08
Exp.Serial2_In		EQU	EXPANDUINO+2
Exp.Serial2_In_Mask	EQU	$10
Exp.Serial2_Out		EQU	EXPANDUINO+2
Exp.Serial2_Out_Mask	EQU	$20
Exp.Serial3_In		EQU	EXPANDUINO+3
Exp.Serial3_In_Mask	EQU	$40
Exp.Serial3_Out		EQU	EXPANDUINO+3
Exp.Serial3_Out_Mask	EQU	$80
	Serial	"ExpCtrl", Exp.Serial_Status, Exp.Serial_Status_Mask, Exp.Control_Out_Mask, Exp.Serial_Status, Exp.Control_Out	; reading make no sense
	Serial	"Exp1", Exp.Serial_Status, Exp.Serial1_In_Mask, Exp.Serial1_Out_Mask, Exp.Serial1_In, Exp.Serial1_Out
	Serial	"Exp2", Exp.Serial_Status, Exp.Serial2_In_Mask, Exp.Serial2_Out_Mask, Exp.Serial2_In, Exp.Serial2_Out
	Serial	"Exp3", Exp.Serial_Status, Exp.Serial3_In_Mask, Exp.Serial3_Out_Mask, Exp.Serial3_In, Exp.Serial3_Out
; }}}

; ---
	ALIGN $100
Sys.AskExpSerial	; -> X - Exp0 ... Exp3; A given char {{{
	JSR	Sys.PrintImm
	FCN	" which Exp.Serial (0..3)?"
	JSR	Sys.ReadReg
	JSR	Sys.PrintReg	; }}}
Sys.GetExpSerial	; A ('0 ... '3 ) -> X - Exp0 ... Exp3 (else Sys.Ser1) {{{
	CMPA	#'0
	BNE	>
	LDX	#ExpCtrl
	RTS
!	CMPA	#'1
	BNE	>
	LDX	#Exp1
	RTS
!	CMPA	#'2
	BNE	>
	LDX	#Exp2
	RTS
!	CMPA	#'3
	BNE	>
	LDX	#Exp3
	RTS
!	JSR	Sys.PrintImm
	FCN	" 0..3 !",CR,LF
	LDX	#Ser1
	RTS		; }}}
Sys.Loop	; {{{
	JSR	Sys.PrintImm
	FCN	CR,LF,"RWQ? "
	JSR	Sys.ReadReg
	JSR	Sys.RegToUpper
	JSR	Sys.PrintReg
	CMPA	#"Q"
	BNE	>		; {{{
	JSR	Sys.PrintImm
	FCN	" Bye!",CR,LF
	JMP	[INT_RESET]	; }}}
!	CMPA	#'R
	BNE	>		; {{{
	JSR	Sys.PrintImm
	FCN	CR,LF,"Read"
	JSR	Sys.AskExpSerial
1	JSR	Sys.SerReadReg
	CMPA	#0
	BEQ	2f
	JSR	Sys.PrintReg
	BRA	1b
2
	JSR	Sys.PrintImm
	FCN	" (The End)"
	; }}}
!	CMPA	#'W
	BNE	>		; {{{
	JSR	Sys.PrintImm
	FCN	CR,LF,"Write"
	JSR	Sys.AskExpSerial
1	JSR	Sys.ReadReg
	CMPA	#$1B	; <ESC>
	BEQ	2f
	JSR	Sys.PrintReg
	JSR	Sys.SerPrintReg
	CMPA	#13
	BNE	1b
	LDA	#10
	JSR	Sys.PrintReg
	JSR	Sys.SerPrintReg
	BRA	1b
2
	LDA	#0
	JSR	Sys.SerPrintReg
	JSR	Sys.PrintImm
	FCN	" (The End)"
	JMP	Sys.Loop	; }}}
!
__End	JMP	Sys.Loop	; }}}
;
Sys.LoopLength	FDB	* - Sys.Loop
;
;	TFR	A,B		; A->B !!!
;	EXG	A,B
